package com.persagy.dmp.middleware.service.impl;

import com.baomidou.mybatisplus.core.conditions.query.QueryWrapper;
import com.persagy.dmp.middleware.dao.WdDefineTypeRelMapper;
import com.persagy.dmp.middleware.entity.dto.InstanceUrlParam;
import com.persagy.dmp.middleware.entity.vo.WdDefineTypeRel;
import com.persagy.dmp.middleware.service.IWdDefineTypeRelService;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Set;

/**
 * @ClassName ObjectInstanceServiceImpl
 * @Description: 广联达：关系映射表配置
 * @Author linhuili
 * @Date 2021/9/10 11:17
 * @Version V1.0
 **/
@Service
public class WdDefineTypeRelServiceImpl implements IWdDefineTypeRelService {

    @Autowired
    private WdDefineTypeRelMapper wdDefineTypeRelMapper;

    /**
     * 查询广联达映射表
     * @param context
     * @param wdDefineTypeRel
     * @return
     */
    @Override
    public List<WdDefineTypeRel> query(InstanceUrlParam context, WdDefineTypeRel wdDefineTypeRel) {
        QueryWrapper<WdDefineTypeRel> wrapper = new QueryWrapper<>();
        if(StringUtils.isNotEmpty(wdDefineTypeRel.getObjType())){
            wrapper.eq("obj_type",wdDefineTypeRel.getObjType());
        }
        if(StringUtils.isNotEmpty(wdDefineTypeRel.getBimTypeId())){
            wrapper.eq("bim_type_id",wdDefineTypeRel.getBimTypeId());
        }

        if(StringUtils.isNotEmpty(wdDefineTypeRel.getWdSystemCode())){
            wrapper.eq("wd_system_code",wdDefineTypeRel.getWdSystemCode());
        }

        if(StringUtils.isNotEmpty(wdDefineTypeRel.getWdModelCode())){
            wrapper.eq("wd_model_code",wdDefineTypeRel.getWdModelCode());
        }

        List<WdDefineTypeRel> defineTypeRels = wdDefineTypeRelMapper.selectList(wrapper);
        return defineTypeRels;
    }

    /**
     * 批量查询映射表
     * @param wdSystemCodes
     * @param objTypes
     * @return
     */
    @Override
    public List<WdDefineTypeRel> batchQuery(Set<String> wdSystemCodes, Set<String> objTypes) {
        QueryWrapper<WdDefineTypeRel> wrapper = new QueryWrapper<>();

        wrapper.in("obj_type",objTypes);
        wrapper.in("wd_system_code",wdSystemCodes);
        return  wdDefineTypeRelMapper.selectList(wrapper);
    }

}
